package BottleRocket;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;
require DynaLoader;
require AutoLoader;

@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	
);
$VERSION = '0.01';

bootstrap BottleRocket $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

BottleRocket - Perl extension for controlling X10 Firecracker kits.

=head1 SYNOPSIS

  use BottleRocket;
  BottleRocket::x10_cmd(FILEHANDLE, DEVICE_ID, COMMAND);

=head1 DESCRIPTION

This is version 0.01 of the BottleRocket perl module.  Usage is 
straightforward:  use open to get a filehandle to the device controlling the
FireCracker and call x10_cmd with the filehandle, the ID of the device to
control (e.g. A10) and the command you want to execute (e.g. "ON").  Note 
that for a DEVICE_ID, only "ON" and "OFF" take a numeric part; the rest
just take the housecode (letter) of the devices to operate upon, as the
protocol does not include the ability to address a specific device with these
commands ("DIM" and "BRIGHT" will affect the last device that was issued 
an "ON" command).


example:


use BottleRocket;

open(FH, "/dev/cua0");
BottleRocket::x10_cmd(FH, "A10", "ON");
BottleRocket::x10_cmd(FH, "A10", "DIM");
close(FH);


This will turn on the device whose address is A10 and dim it one notch 
(assuming it's plugged into a lamp module).

Valid commands are:  ON, OFF, DIM, BRIGHT, ALL_ON, ALL_OFF, LIGHTS_ON,
LIGHTS_OFF

Note that currently this will return undef if any arguments were not valid; I
will probably change it so it will croak with some kind of meaningful 
message instead.  This code is crud, but it works.  It will likely change
very much in the future.

=head1 AUTHOR

Timothy Twillman, tymm@acm.org

=head1 SEE ALSO

perl(1).

=cut
