#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <string.h>
#include "../br_cmd.h"

int br_getcmd(char *arg)
{
/*
 * Convert a BottleRocket command to the appropriate token
 */

    if (!strcasecmp(arg, "ON"))
        return ON;

    if (!strcasecmp(arg, "OFF"))
        return OFF;

    if (!strcasecmp(arg, "DIM"))
        return DIM;

    if (!strcasecmp(arg, "BRIGHT"))
        return BRIGHT;

    if (!strcasecmp(arg, "ALL_ON"))
        return ALL_ON;

    if (!strcasecmp(arg, "ALL_OFF"))
        return ALL_OFF;

    if (!strcasecmp(arg, "LAMPS_ON"))
        return ALL_LAMPS_ON;

    if (!strcasecmp(arg, "LAMPS_OFF"))
        return ALL_LAMPS_OFF;

    return -1;
}


MODULE = BottleRocket		PACKAGE = BottleRocket		

void
x10_cmd(file, unit_in, cmd_in)
	FILE *file
	char *unit_in
	char *cmd_in;

	PREINIT:
	char unit_out;
	int cmd_out;
	int tmpval;
	int fd;
	SV *rv;

	CODE:

	do {

		if (file == NULL) {
			rv = &PL_sv_undef;
			break;
		}

		fd = fileno(file);

		if (fd < 0) {
			rv = &PL_sv_undef;
			break;
		}

		cmd_out = br_getcmd(cmd_in);
		
		if (cmd_out < 0) {
			rv = &PL_sv_undef;
		    	break;
		}

		if ((cmd_out == ON) || (cmd_out == OFF)) {
			if (strlen(unit_in) != 2) {
				rv = &PL_sv_undef;
				break;
			}
		} else {
			if (strlen(unit_in) != 1) {
				rv = &PL_sv_undef;
				break;
			}
		}

		tmpval = unit_in[0] - 'A';
		if ((tmpval < 0) || (tmpval > 15)) {
			rv = &PL_sv_undef;
			break;
		}

		unit_out = tmpval << 4;

		tmpval = atoi(&unit_in[1]);
		if ((tmpval < 0) || (tmpval > 15)) {
			rv = &PL_sv_undef;
			break;
		}

		unit_out |= tmpval;

		if (x10_br_out(fd, tmpval, cmd_out) < 0) {
			rv = &PL_sv_undef;
			break;
		}

		rv = newSViv(1);
	} while (0);

	ST(0) = rv;
	XSRETURN(1);
